(function () {
  var table = document.getElementById('ttable')
  var input = document.getElementById('search')
  var audio = document.getElementById('player')
  var playing = document.getElementById('playing')

  var menu = document.getElementById('menu')

  var tableHead = '<tr> \
    <th class="small">#</th> \
    <th>Track</th> \
    <th>Artist</th> \
    <th>Album</th> \
    <th class="small">Year</th> \
    <th class="small">Duration</th> \
  </tr>'
  var nowPlaying = 0

  var pageNum = 0
  var pages = 1
  var paginator = document.querySelector('.pages')
  var pageNumText = document.querySelector('.pages #pagenum')

  // Search saves
  var searching = false
  var pagePrev = 0
  var pagesPrev = 0

  // Queueing
  var queue = []
  var qTag = document.getElementById('queue')

  // Playlists
  var playlist = null
  var pSel = document.getElementById('playlist-select')

  window.mobilecheck = function() {
    var check = false;
    (function(a){if(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(a)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0,4))) check = true;})(navigator.userAgent||navigator.vendor||window.opera);
    return check
  }
  window.isMobile = window.mobilecheck()

  // Context bullshit
  let playerContext = []

  window.resumeContexts = function () {
    for (let i in playerContext) {
      let ctx = playerContext[i]
      if (ctx && ctx.resume) {
        ctx.resume().catch(function (e) {
          console.error(e)
          alert('Failed to play:', e.message)
        })
      }
    }
  }

  window.attachAudioContext = function (ctx) {
    playerContext.push(ctx)
  }

  // Seconds into HH:MM:SS
  function toHHMMSS (numbr) {
    let secNum = parseInt(numbr, 10) // don't forget the second param
    let hours = Math.floor(secNum / 3600)
    let minutes = Math.floor((secNum - (hours * 3600)) / 60)
    let seconds = secNum - (hours * 3600) - (minutes * 60)

    if (hours < 10) hours = '0' + hours
    if (minutes < 10) minutes = '0' + minutes
    if (seconds < 10) seconds = '0' + seconds

    let time = ''
    if (parseInt(hours) > 0) {
      time = hours + ':' + minutes + ':' + seconds
    } else {
      time = minutes + ':' + seconds
    }
    return time
  }

  function httpGet (url, callback) {
    return new Promise(function (resolve, reject) {
      var xmlHttp = new XMLHttpRequest()
      xmlHttp.onreadystatechange = function () {
        if (xmlHttp.readyState === 4 && xmlHttp.status === 200) {
          resolve(JSON.parse(xmlHttp.responseText))
        } else if (xmlHttp.readyState === 4) {
          reject(new Error(xmlHttp.status))
        }
      }
      xmlHttp.open('GET', url, true)
      xmlHttp.send(null)
    })
  }

  function shortTitle (title, artist) {
    if (!artist) return title
    return artist + ' - ' + title
  }

  function handleHash (hash) {
    if (hash.indexOf('#') === 0) hash = hash.substr(1)
    if (hash.length === 0) return

    window.location.hash = ''

    if (hash.indexOf('track-') === 0) {
      let trackNr = parseInt(hash.substr(6))
      if (!isNaN(trackNr)) return play(trackNr)
    }
  }

  function clickInsideElement (e, className) {
    var el = e.srcElement || e.target

    if (el.classList.contains(className)) {
      return el
    } else {
      while (el = el.parentNode) {
        if (el.classList && el.classList.contains(className)) {
          return el
        }
      }
    }

    return false
  }

  function getPosition(e) {
    var posx = 0
    var posy = 0

    if (!e) var e = window.event

    if (e.pageX || e.pageY) {
      posx = e.pageX
      posy = e.pageY
    } else if (e.clientX || e.clientY) {
      posx = e.clientX + document.body.scrollLeft + 
                         document.documentElement.scrollLeft
      posy = e.clientY + document.body.scrollTop + 
                         document.documentElement.scrollTop
    }

    return {
      x: posx,
      y: posy
    }
  }

  function positionMenu(e) {
    clickCoords = getPosition(e)
    clickCoordsX = clickCoords.x
    clickCoordsY = clickCoords.y

    menuWidth = menu.offsetWidth + 4
    menuHeight = menu.offsetHeight + 4

    windowWidth = window.innerWidth
    windowHeight = window.innerHeight

    if ( (windowWidth - clickCoordsX) < menuWidth ) {
      menu.style.left = windowWidth - menuWidth + 'px'
    } else {
      menu.style.left = clickCoordsX + 'px'
    }

    if ( (windowHeight - clickCoordsY) < menuHeight ) {
      menu.style.top = windowHeight - menuHeight + 'px'
    } else {
      menu.style.top = clickCoordsY + 'px'
    }
  }

  function removeFromQueue (id) {
    var index = queue.indexOf(id)
    if (index > -1) {
      queue.splice(index, 1)
    }
  }

  var ctxState = 0
  function ctxHide () {
    ctxState = 0
    menu.style.display = 'none'
  }

  function updateQT (q) {
    if (playlist === 0) showTracks(pageNum)
    if (q) {
      qTag.style.display = 'block'
      var cnt = '+' + queue.length
      if (queue.length === 0) cnt = '%'
      qTag.innerHTML = 'Queue ' + cnt
      return
    }
    qTag.style.display = 'none'
  }

  function ctxHandle (el) {
    if (ctxState === 0) return
    let dt = el.getAttribute("data-action")
    switch (dt) {
      case 'play':
        play(ctxState)
        break
      case 'queue':
        if (playlist === 0)
          removeFromQueue(ctxState)
        else
          queue.push(ctxState)
        break
      case 'download':
        audio.pause()
        window.open('/api/serve/by-id/' + ctxState + '?dl=1', '_blank')
        break
    }
    ctxHide()
    updateQT(qTag.style.display === 'block')
  }

  function ctxTrack (xid, ev, qe) {
    positionMenu(ev)
    menu.style.display = 'block'

    let qbtn = menu.querySelector('.ctx-item[data-action="queue"]')
    qbtn.innerHTML = qe ? 'Remove from Queue' : 'Queue Track'

    ctxState = xid
  }

  function trackDataRow (track) {
    let title = window.isMobile ? shortTitle(track.title, track.artist) : track.title
    let trTag = document.createElement('tr')
    trTag.className = 'track'
    trTag.setAttribute('data-id', track.id)
    trTag.innerHTML += '<td>' + track.id + '</td>'
    trTag.innerHTML += '<td>' + title + '</td>'
    trTag.innerHTML += '<td>' + (track.artist || '') + '</td>'
    trTag.innerHTML += '<td>' + (track.album || '') + '</td>'
    trTag.innerHTML += '<td>' + (track.year || '') + '</td>'
    trTag.innerHTML += '<td>' + toHHMMSS(track.duration) + '</td>'
    return trTag
  }

  function constructList (tracks) {
    table.innerHTML = tableHead

    for (let i in tracks) {
      let track = tracks[i]
      let tag = trackDataRow(track)

      tag.addEventListener('click', function (e) {
        play(track.id)
      }, false)

      tag.addEventListener('contextmenu', function (e) {
        e.preventDefault()
        ctxTrack(track.id, e)
      }, false)

      table.appendChild(tag)
    }
  }

  function recursionQueueList (index) {
    let qid = queue[index]
    if (!qid || playlist !== 0) return

    httpGet('/api/track/' + qid).then(function (data) {
      let tag = trackDataRow(data)

      tag.addEventListener('contextmenu', function (e) {
        e.preventDefault()
        ctxTrack(qid, e, true)
      }, false)

      table.appendChild(tag)

      recursionQueueList(index + 1)
    }, function (e) {
      console.log(e)
    })
  }

  function constructQueue () {
    table.innerHTML = tableHead
    recursionQueueList(0)
  }

  function updatePaging () {
    if (pages > 1) {
      paginator.style.display = 'flex'
    } else {
      paginator.style.display = 'none'
      return
    }

    pageNumText.innerHTML = pageNum + ' / ' + pages
  }

  function showTracks (page) {
    let query = input.value
    if (searching && query.trim() === '') {
      searching = false
      pagePrev = 0
      pages = pagesPrev
    }

    if (page > pages) return
    if (page < 1) return
    updatePaging()

    if (playlist === 0) {
      return constructQueue()
    }

    if (query.trim() === '') {
      return httpGet('/api/tracks?page=' + page).then(function (data) {
        pageNum = page
        pages = data.pageCount
        constructList(data.tracks)
        updatePaging()
      })
    }

    if (!searching) {
      pagePrev = pageNum
      pagesPrev = pages
      searching = true
    }

    httpGet('/api/tracks/search?q=' + query + '&page=' + page).then(function (data) {
      pageNum = page
      pages = data.pageCount
      constructList(data.tracks)
      updatePaging()
    })
  }

  function play (id, q) {
    if (id < 1) return playNext()
    httpGet('/api/track/' + id).then(function (data) {
      let title = shortTitle(data.title, data.artist)
      playing.innerHTML = title
      document.title = title

      audio.src = '/api/serve/by-id/' + id
      audio.play()

      window.resumeAudioContexts()

      updateQT(q)

      nowPlaying = id
    }, function (e) {
      console.log(e)
    })
  }

  function playNext () {
    if (queue.length === 0) return play(nowPlaying + 1)
    play(queue.shift(), true)
  }

  function showPlaylist (pid) {
    
  }

  function handleSelect () {
    let btn = pSel.querySelector('.dropdown-button')
    let btns = pSel.querySelectorAll('.dropdown-content div')

    for (let i in btns) {
      let btni = btns[i]
      if (!(btni instanceof Element)) continue
      let cnt = btni.getAttribute('data-value')

      btni.addEventListener('click', function (e) {
        btn.innerHTML = btni.innerHTML
        switch (cnt) {
          case 'all':
            playlist = null
            break
          case 'queue':
            playlist = 0
            break
          default:
            showPlaylist(cnt)
        }
        showTracks(pageNum)
      }, false)
    }
  }

  input.addEventListener('keyup', function (e) {
    e.which === 13 && showTracks(input.value.trim() === '' ? (pagePrev !== 0 ? pagePrev : 1) : 1)
  }, false)

  audio.addEventListener('ended', playNext, false)

  document.getElementById('player-next').addEventListener('click', playNext, false)

  document.getElementById('player-prev').addEventListener('click', function (e) {
    play(nowPlaying - 1)
  }, false)

  document.getElementById('jump-first').addEventListener('click', function (e) {
    showTracks(1)
  }, false)

  document.getElementById('jump-prev').addEventListener('click', function (e) {
    showTracks(pageNum - 1)
  }, false)

  document.getElementById('jump-next').addEventListener('click', function (e) {
    showTracks(pageNum + 1)
  }, false)

  document.getElementById('jump-last').addEventListener('click', function (e) {
    showTracks(pages)
  }, false)

  window.addEventListener('hashchange', function (e) {
    e.preventDefault()
    handleHash(window.location.hash)
  }, false)

  window.addEventListener('resize', function (e) {
    ctxHide()
  }, false)

  document.addEventListener('click', function(e) {
    var clickeElIsLink = clickInsideElement(e, 'ctx-item')

    if (clickeElIsLink) {
      e.preventDefault()
      ctxHandle(clickeElIsLink)
    } else {
      var button = e.which || e.button
      if ( button === 1 ) {
        ctxHide()
      }
    }
  })

  showTracks(1)
  handleHash(window.location.hash)
  handleSelect()
})()
